using System.Runtime.InteropServices;
using ObjCRuntime;

namespace cancelOperationTest;

[Register("MyNSTableView")]
public class MyNSTableView : NSTableView
{
    public MyNSTableView(NSCoder coder) : base(coder)
    {
    }

    protected internal MyNSTableView(NativeHandle handle) : base(handle)
    {
    }

    
    [DllImport ("/usr/lib/libobjc.dylib", EntryPoint = "objc_msgSend")]
    private static extern void void_objc_msgSend (NativeHandle receiver, NativeHandle selector, NativeHandle value);

    [DllImport ("/usr/lib/libobjc.dylib", EntryPoint = "objc_msgSend")]
    private static extern void objc_msgSendSuper(NativeHandle superReceiver, NativeHandle selector, NativeHandle value);
    
    //  [ProtocolMember(IsRequired = false, IsProperty = false, IsStatic = false, Name = "CancelOperation", Selector = "cancelOperation:", ParameterType = new Type[] {typeof (NSObject)}, ParameterByRef = new bool[] {false})]
    [Export("cancelOperation:")]
    private void CancelOperation(NSObject? sender)
    {
        // some custom processing
        System.Diagnostics.Debug.WriteLine("Custom processing");
        
        //won't compile
        //base.CancelOperation(sender);
        
        //crashes the app
        objc_msgSendSuper(this.SuperHandle, Selector.GetHandle("cancelOperation:"), sender?.Handle ?? NativeHandle.Zero);
        
        //another part of custom processing
        System.Diagnostics.Debug.WriteLine("another part of custom processing");

    }
}